/***************************************************************************/
/**                                                                       **/
/**              MODULAR-4 library for SPB module M-DC15-2                **/
/**                                                                       **/
/**  This file contains routines for Borland C++/3.1 to allow the user,   **/
/**  to write programs for the MODULAR-4 in "C" 			  **/
/**                                                                       **/
/**                             Version 2.D.                              **/
/**                                                                       **/
/**                    Last change : 28.11.1996                           **/
/**                    Adaptation to Windows 95, Windows NT and OS/2	  **/
/**                                                                       **/
/**                             Version 2.C.                              **/
/**                                                                       **/
/**  This file contains routines for Borland C++/3.1 to allow the user,   **/
/**  to write programs for the MODULAR-4 in "C" 			  **/
/**                                                                       **/
/**                    Last change : 19.05.1995                           **/
/**                    Windows-DLLs for ML4 and ML5                       **/
/**                    Last change : 14.10.1994                           **/
/**               ml8_read_eeprom changed to ml8_read_eeprom_copy 	  **/
/**                                                                       **/
/**                Date of release : 04.02.1994                           **/
/**                    Last change : 04.02.1994                           **/
/**                         Author : H.K.                                 **/
/**                         Status : O.K.				  **/
/**                                                                       **/
/**                                                                       **/
/** This library was tested with Borland C++ Version 3.1.	          **/
/**                                                                       **/
/** No parameters are checked.						  **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/**               (c) SORCUS Computer GmbH 1995/1996                      **/
/**                                                                       **/
/***************************************************************************/

/* The switches for the library are set in the configuration files of Pascal
   (*.TP file) and C (project-file). They can also be set in this source file:

   Then the following #defines have to exist:

   If you use Pascal, #define BORLAND_PASCAL has to be included (default is C).

   If the library shall be used as realtime library on the MODULAR-4/486
   #define ML8 and #define ML8RT have to be included (default is PC library).

   If you work with Windows, this is detected by the compiler. No #defines have
   to be included.
*/


#include "m034_lib.h"

/* Static Arrays */

       STATIC byte m034intconf[ANZ_MOD];
       STATIC byte m034ledconf[ANZ_MOD];


#if defined (__DLL__) && !defined (__OS2__)/* if a module DLL shall be generated */

#include <windows.h>

HANDLE   hInst;

#pragma argsused

int far pascal LibMain(hInstance, wDataSeg, wHeapSize, lpszCmdLine)
HANDLE  hInstance;                /* Instance of DLL          */
WORD    wDataSeg;                 /* Data segment             */
WORD    wHeapSize;                /* Size of heap 	      */
LPSTR   lpszCmdLine;              /* Pointer to command line  */

{

  hInst = hInstance;

  if (wHeapSize > 0) UnlockData(0);

  return(1);
}

#endif  /* __DLL__ */

/* Init module library
*/
MLXAPI void EXPORT m034_bib_startup(void)
{
 ushort w;
 short m,endm;

  if (lobyte(mlx_read_eeprom(1,0)) == 0x29)    /* Check, whether module extender is used */
    endm = ANZ_MOD;                            /* Max. number of micro-slots */
  else
    endm = 5;                                  /* 4 micro-slots */
  for (m=1;m < endm;m++) {                     /* Check all micro-slots */
    if (lobyte(mlx_read_eeprom(m,0)) == 0x22) {/* Correct module ? */
      w = mlx_read_eeprom(m,3);                /* Read configuration from EEPROM */
      m034ledconf[m] = lobyte(w);              /* and store it in local arrays */
      m034intconf[m] = hibyte(w);
    }
    else {
      m034ledconf[m] = 0;                /* Init local arrays */
      m034intconf[m] = 0;
    }
  }
}

/* Configure all devices of the module
*/
MLXAPI void EXPORT m034_set_conf_all(byte micro_slot,
			      byte ledconf,
			      byte intconf)
{
 byte loop;
 byte v;

  m034ledconf[micro_slot] = ledconf;        /* Store configuration in library */
  loop = 0;
  do {                                    /* Check all LED's */
    v = 1 << loop;
    if ((ledconf & v) == v) {
      mlx_out_port(MBASIS+(loop*2),0);    /* Switch on LED */
    }
    else {
      mlx_out_port(MBASIS+(loop*2)+1,0);  /* Switch off LED */
    }
    loop = loop + 1;
  } while (loop != 8);
  m034intconf[micro_slot] = intconf;        /* Store configuration in library */
  loop = 0;
  do {
    v = 1 << loop;
    if ((intconf & v) == v) {
      mlx_out_port(MBASIS+M034_CON_IP0_INT3+(loop*2),0);   /* Connect INT-x */
    }
    else {
      mlx_out_port(MBASIS+M034_CUT_IP0_INT3+(loop*2),0);   /* Disconnect INT-x */
    }
    loop = loop + 1;
  } while (loop != 4);
}

/* Configure one device
*/
MLXAPI void EXPORT m034_set_conf_detail(byte micro_slot,
				 byte ipx,
				 byte data_var)
{

  switch (ipx) {
    case 0 : {
	      if (data_var == 0) {
		mlx_out_port(MBASIS+M034_CON_IP0_INT3,0);
		m034intconf[micro_slot] = m034intconf[micro_slot] | 0x1;
	      }
	      else {
		mlx_out_port(MBASIS+M034_CUT_IP0_INT3,0);
		m034intconf[micro_slot] = m034intconf[micro_slot] & 0xFE;
	      }
	      break;
	     }
    case 1 : {
	      if (data_var == 0) {
		mlx_out_port(MBASIS+M034_CON_IP1_INT4,0);
		m034intconf[micro_slot] = m034intconf[micro_slot] | 0x2;
	      }
	      else {
		mlx_out_port(MBASIS+M034_CUT_IP1_INT4,0);
		m034intconf[micro_slot] = m034intconf[micro_slot] & 0xFD;
	      }
	     break;
	     }
    case 2 : {
	      if (data_var == 0) {
		mlx_out_port(MBASIS+M034_CON_IP2_INT5,0);
		m034intconf[micro_slot] = m034intconf[micro_slot] | 0x4;
	      }
	      else {
		mlx_out_port(MBASIS+M034_CUT_IP2_INT5,0);
		m034intconf[micro_slot] = m034intconf[micro_slot] & 0xFB;
	      }
	     break;
	     }
    case 3 : {
	      if (data_var == 0) {
		mlx_out_port(MBASIS+M034_CON_IP3_INT7,0);
		m034intconf[micro_slot] = m034intconf[micro_slot] | 0x8;
	      }
	      else {
		mlx_out_port(MBASIS+M034_CUT_IP3_INT7,0);
		m034intconf[micro_slot] = m034intconf[micro_slot] & 0xF7;
	      }
	     break;
	     }
    }
}

/* Read configuration
*/
MLXAPI void EXPORT m034_get_conf_all(byte micro_slot,
			      byte *ledconf,
			      byte *intconf)
{

  *ledconf = m034ledconf[micro_slot];
  *intconf = m034intconf[micro_slot];
}

/* Init module like definitions in EEPROM
*/
MLXAPI void EXPORT m034_set_conf_eeprom(byte micro_slot)
{
 byte loop;
 byte v;

  m034_bib_startup();
  loop = 0;
  do {                                                          /* Check all LED's */
    v = 1 << loop;
    if ((m034ledconf[micro_slot] & v) == v) {
      mlx_out_port(MBASIS+M034_SWITCH_LED0_ON+(loop*2),0);      /* Switch on LED */
    }
    else {
      mlx_out_port(MBASIS+M034_SWITCH_LED0_OFF+(loop*2),0);     /* Switch off LED */
    }
    loop = loop + 1;
  } while (loop != 8);
  loop = 0;
  do {
    v = 1 << loop;
    if ((m034intconf[micro_slot] & v) == v) {
      mlx_out_port(MBASIS+M034_CON_IP0_INT3+(loop*2),0);   /* Connect INT-x */
    }
    else {
      mlx_out_port(MBASIS+M034_CUT_IP0_INT3+(loop*2),0);   /* Disconnect INT-x */
    }
    loop = loop + 1;
  } while (loop != 4);
}

/* Read status of all inputs IPx
*/
MLXAPI void EXPORT m034_get_ipx(byte micro_slot,
			 byte *data_var)
{
  byte w1,w2;

   w1 = mlx_in_port(MBASIS+M034_READ_STAT_IP01);         /* Read IP-0 and IP-1 */
   w2 = mlx_in_port(MBASIS+M034_READ_STAT_IP23);         /* Read IP-2 and IP-3 */
   *data_var = (w1 & 0x3) + ((w2 & 0x3) << 2);
}

/* Set one LED
*/
MLXAPI void EXPORT m034_set_led(byte micro_slot,
			 byte led,
			 byte data_var)
{
  if (data_var == 1) {
    mlx_out_port(MBASIS+(led << 1),0);       /* Switch on LED */
    m034ledconf[micro_slot] = m034ledconf[micro_slot] | (1 << led);
    }
  else {
    mlx_out_port(MBASIS+(led << 1) + 1,0);       /* Switch off LED */
    m034ledconf[micro_slot] = m034ledconf[micro_slot] & (0xff ^ (1 << led));
    }
}

/* Read status of all LEDs
*/
MLXAPI void EXPORT m034_get_led(byte micro_slot,
			     byte *ledconf)
{
  *ledconf = m034ledconf[micro_slot];             /* Read configuration from library */
}


