#ifndef _m034_lib_
#define _m034_lib_
/***************************************************************************/
/**                                                                       **/
/**              MODULAR-4 library for SPB module M-DC15-2                **/
/**                                                                       **/
/**                             Version 2.D.                              **/
/**                                                                       **/
/**                    Last change : 28.11.1996                           **/
/**                    Adaptation to Windows 95, Windows NT and OS/2	  **/
/**                                                                       **/
/**                             Version 2.C.                              **/
/**                                                                       **/
/**  This file contains routines for Borland C++/3.1 to allow the user,   **/
/**  to write programs for the MODULAR-4 in "C" 			  **/
/**                                                                       **/
/**                Date of release : 04.02.1994                           **/
/**                    Last change : 18.05.1995                           **/
/**                         Author : H.K.                                 **/
/**                         Status : O.K.				  **/
/**                                                                       **/
/**                                                                       **/
/** Special comments: 							  **/
/**                                                                       **/
/** This library was tested with Borland C++ Version 3.1.	          **/
/**                                                                       **/
/** No parameters are checked.						  **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/**               (c) SORCUS Computer GmbH 1995/1996                      **/
/**                                                                       **/
/***************************************************************************/

/* The switches for the library are set in the configuration files of Pascal
   (*.TP file) and C (project-file). They can also be set in this source file:

   Then the following #defines have to exist:

   If you use Pascal, #define BORLAND_PASCAL has to be included (default is C).

   If the library shall be used as realtime library on the MODULAR-4/486
   #define ML8 and #define ML8RT have to be included (default is PC library).

   If you work with Windows, this is detected by the compiler. No #defines have
   to be included.
*/

#include <MODULE.H>

#define MBASIS               micro_slot_basis[micro_slot] /* Module base address */
#define M034_CUT_IP0_INT3    0x10                          /* Disconnect IP0 from INT-3/IRQ-B */
#define M034_CON_IP0_INT3    0x11                          /* Connect IP0 with INT-3/IRQ-B */
#define M034_CUT_IP1_INT4    0x12                          /* Disconnect IP1 from INT-4/IRQ-E */
#define M034_CON_IP1_INT4    0x13                          /* Connect IP1 with INT-4/IRQ-E */
#define M034_CUT_IP2_INT5    0x14                          /* Disconnect IP2 from INT-5/IRQ-C */
#define M034_CON_IP2_INT5    0x15                          /* Connect IP2 with INT-5/IRQ-C */
#define M034_CUT_IP3_INT7    0x16                          /* Disconnect IP3 from INT-7/IRQ-D */
#define M034_CON_IP3_INT7    0x17                          /* Connect IP3 with INT-7/IRQ-D */
#define M034_READ_STAT_IP01  0x18                          /* Read status of IP0 and IP1 */
#define M034_READ_STAT_IP23  0x19                          /* Read status of IP2 and IP3 */
#define M034_READ_CON_IP01   0x1A                          /* Check, whether IP0 is connected with INT-3/IRQ-B and IP1 with INT-4/IRQ-E */
#define M034_READ_CON_IP23   0x1B                          /* Check, whether IP2 is connected with INT-5/IRQ-C and IP3 with INT-7/IRQ-D */
#define M034_SWITCH_LED0_ON  0x0                           /* Switch on LED 0 */
#define M034_SWITCH_LED0_OFF 0x1                           /* Switch off LED 0 */
#define M034_SWITCH_LED1_ON  0x2                           /* Switch on LED 1 */
#define M034_SWITCH_LED1_OFF 0x3                           /* Switch off LED 1 */
#define M034_SWITCH_LED2_ON  0x4                           /* Switch on LED 2 */
#define M034_SWITCH_LED2_OFF 0x5                           /* Switch off LED 2 */
#define M034_SWITCH_LED3_ON  0x6                           /* Switch on LED 3 */
#define M034_SWITCH_LED3_OFF 0x7                           /* Switch off LED 3 */
#define M034_SWITCH_LED4_ON  0x8                           /* Switch on LED 4 */
#define M034_SWITCH_LED4_OFF 0x9                           /* Switch off LED 4 */
#define M034_SWITCH_LED5_ON  0xA                           /* Switch on LED 5 */
#define M034_SWITCH_LED5_OFF 0xB                           /* Switch off LED 5 */
#define M034_SWITCH_LED6_ON  0xC                           /* Switch on LED 6 */
#define M034_SWITCH_LED6_OFF 0xD                           /* Switch off LED 6 */
#define M034_SWITCH_LED7_ON  0xE                           /* Switch on LED 7 */
#define M034_SWITCH_LED7_OFF 0xF                           /* Switch off LED 7 */


#if defined(__cplusplus)
extern "C" {
#endif

/* Init module library
*/
MLXAPI void EXPORT m034_bib_startup (void);

/* Configure all devices
*/
MLXAPI void EXPORT m034_set_conf_all (byte micro_slot,
			       byte ledconf,
			       byte intconf);

/* Configure one device
*/
MLXAPI void EXPORT m034_set_conf_detail (byte micro_slot,
				  byte ipx,
				  byte data_var);

/* Read configuration
*/
MLXAPI void EXPORT m034_get_conf_all (byte micro_slot,
			       byte *ledconf,
			       byte *intconf);

/* Configure modul like definitions in EEPROM
*/
MLXAPI void EXPORT m034_set_conf_eeprom (byte micro_slot);

/* Read status of all inputs IPx
*/
MLXAPI void EXPORT m034_get_ipx (byte micro_slot,
			  byte *data_var);

/* Set all LEDs
*/
MLXAPI void EXPORT m034_set_led (byte micro_slot,
			  byte led,
			  byte data_var);

/* Read status of all LEDs
*/
MLXAPI void EXPORT m034_get_led (byte micro_slot,
			  byte *ledconf);

#if defined(__cplusplus)
} /*  End of block of extern "C" */
#endif

#endif