{$C MOVEABLE DEMANDLOAD DISCARDABLE}
(***************************************************************************)
(**                                                                       **)
(**              MODULAR-4 library for SPB module M-DC15-2                **)
(**                                                                       **)
(**  This file contains routines for Borland Pascal to allow the user,    **)
(**  to write programs for the MODULAR-4 in "Pascal" 			  **)
(**                                                                       **)
(**                             Version 2.D.                              **)
(**                                                                       **)
(**                    Last change : 28.11.1996                           **)
(**                    Adaptation to Windows 95, Windows NT and OS/2      **)
(**                                                                       **)
(**                             Version 2.C.                              **)
(**                                                                       **)
(**                    Last change : 19.05.1995                           **)
(**                    Windows DLLs for ML4 and ML5                       **)
(**                Date of release : 04.02.1994                           **)
(**                    Last change : 04.02.1994                           **)
(**                         Author : H.K.                                 **)
(**                         Status : O.K.                                 **)
(**                                                                       **)
(**                                                                       **)
(** Special comments: 							  **)
(**                                                                       **)
(** This library was tested with Borland Pascal Version 7.0.	          **)
(**                                                                       **)
(** No parameters are checked.						  **)
(**                                                                       **)
(**                                                                       **)
(**                                                                       **)
(**               (c) SORCUS Computer GmbH 1995/1996                      **)
(**                                                                       **)
(***************************************************************************)

(* The switches for the library are set in the configuration files of Pascal
   (*.TP file) and C (project-file). They can also be set in this source file:

   Then the following #defines have to exist:

   If you use Pascal, #define BORLAND_PASCAL has to be included (default is C).

   If the library shall be used as realtime library on the MODULAR-4/486
   #define ML8 and #define ML8RT have to be included (default is PC library).

   If you work with Windows, this is detected by the compiler. No #defines have
   to be included.
*)

unit m034_lib;
interface
uses
{$IFDEF ML8}
        {$IFDEF Windows}
                wml8bib;        (* Include library for MODULAR-4/486 under Windows *)
        {$ELSE}
               {$IFDEF ML8RT}
                       ml8rtbib;    (* Include library for MODULAR-4/486 realtime programs *)
               {$ELSE}
                       ml8bib;      (* Include library for MODULAR-4/486 under DOS *)
               {$ENDIF}
        {$ENDIF}
{$ELSE}
        {$IFDEF Windows}
                wml4bib,wml4deb;    (* Include library for MODULAR-4/Z80 under WINDOWS *)
        {$ELSE}
                ml4bib,ml4deb;      (* Include library for MODULAR-4/Z80 under DOS *)
        {$ENDIF}
{$ENDIF}

{$IFDEF Windows}
const
     M034DLL = 'M034_LIB';
{$ENDIF}

(* Init module library *)

procedure m034_bib_startup;

(* Configure module *)

procedure m034_set_conf_all(modul,ledconf,intconf:byte);

(* Configure one device of module *)

procedure m034_set_conf_detail(modul,ipx,data_var:byte);

(* Read configuration *)

procedure m034_get_conf_all(modul:byte;var ledconf,intconf:byte);

(* Init module like definitions in EEPROM *)

procedure m034_set_conf_eeprom(modul:byte);

(* Read status of all inputs IPn *)

procedure m034_get_ipx(modul:byte;var data_var:byte);

(* Set all LEDs *)

procedure m034_set_led(modul,led,data_var:byte);

(* Read status of all LEDs *)

procedure m034_get_led(modul:byte;var ledconf:byte);

implementation

{$IFNDEF Windows}   (* If no DLL is used, .OBJ file has to be included *)

{$L m034_lib.obj}

{$ENDIF}

(* Init module library *)

procedure m034_bib_startup;
          external {$IFDEF Windows} M034DLL {$ENDIF};

(* Configure module *)

procedure m034_set_conf_all(modul,ledconf,intconf:byte);
          external {$IFDEF Windows} M034DLL {$ENDIF};

(* Configure one device of module *)

procedure m034_set_conf_detail(modul,ipx,data_var:byte);
          external {$IFDEF Windows} M034DLL {$ENDIF};

(* Read configuration *)

procedure m034_get_conf_all(modul:byte; var ledconf,intconf:byte);
          external {$IFDEF Windows} M034DLL {$ENDIF};

(* Init module like definitions in EEPROM *)

procedure m034_set_conf_eeprom(modul:byte);
          external {$IFDEF Windows} M034DLL {$ENDIF};

(* Read status of all inputs IPn *)

procedure m034_get_ipx(modul:byte; var data_var:byte);
          external {$IFDEF Windows} M034DLL {$ENDIF};

(* Set all LEDs *)

procedure m034_set_led(modul,led,data_var:byte);
          external {$IFDEF Windows} M034DLL {$ENDIF};

(* Read status of all LEDs *)

procedure m034_get_led(modul:byte;var ledconf:byte);
          external {$IFDEF Windows} M034DLL {$ENDIF};

begin
end.